#!/usr/bin/env python

# An example script using the rumba package

from rumba.model import *
from rumba.utils import ExperimentManager

# import testbed plugins
import rumba.testbeds.local as local

# import prototype plugins
import rumba.prototypes.ouroboros as our

import rumba.log as log

log.set_logging_level('DEBUG')


n1 = UnicastLayer("n1")
n2 = UnicastLayer("n2")
e1 = EthDixLayer("e1")
e2 = EthDixLayer("e2")
e3 = EthDixLayer("e3")

a = Node("a",
         layers = [e1, n1, n2],
         registrations = {n1 : [e1], n2 : [n1]})

b = Node("b",
         layers = [e1, e2, n1],
         registrations = {n1 : [e1, e2]})

c = Node("c",
         layers = [e2, e3, n1],
         registrations = {n1 : [e2, e3]})

d = Node("d",
         layers = [e3, n1, n2],
         registrations = {n1 : [e3], n2 : [n1]})

tb = local.Testbed(exp_name="example1")

exp = our.Experiment(tb, nodes = [a, b, c, d])

print(exp)

# with ExperimentManager(exp):
#    exp.swap_in()
#    exp.bootstrap_prototype()
